/******************************************************************************
**
** memedit_parser.c
**
** Tue Jun 14 14:48:34 2011
** Linux 2.6.39-1-686-pae (#1 SMP Fri May 20 20:40:05 UTC 2011) i686
** mol@parc (Michael Olbrich)
**
** C file for command line parser
**
** Automatically created by genparse v0.5.2
**
** See http://genparse.sourceforge.net/ for details and updates
**
******************************************************************************/

#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdlib.h>
#include <getopt.h>
#include "memedit_parser.h"

/*----------------------------------------------------------------------------
**
** usage()
**
** Print out usage information, then exit
**
**--------------------------------------------------------------------------*/

void usage(char *executable)
{
  printf("usage: %s [ -Vsrhv ] file \n", executable);
  printf("  [ -V ] ");
  printf("[ --verbose  ] ");
  printf("(");
  printf("type=");
  printf("INTEGER,");
  printf(" default=0");
  printf(")\n");
  printf("         verbose output\n");
  printf("  [ -s ] ");
  printf("[ --startfile  ] ");
  printf("(");
  printf("type=");
  printf("STRING");
  printf(")\n");
  printf("         \n");
  printf("         execute startup file\n");
  printf("  [ -r ] ");
  printf("[ --readback  ] ");
  printf("(");
  printf("type=");
  printf("FLAG,");
  printf(")\n");
  printf("         readback on write (default on)\n");
  printf("  [ -h ] ");
  printf("[ --help  ] ");
  printf("(");
  printf("type=");
  printf("FLAG");
  printf(")\n");
  printf("         Display help information.\n");
  printf("  [ -v ] ");
  printf("[ --version  ] ");
  printf("(");
  printf("type=");
  printf("FLAG");
  printf(")\n");
  printf("         Output version.\n");

  exit(1);
}

/*----------------------------------------------------------------------------
**
** free_args()
**
** Call this to free the memory that was dynamically allocated by the parser.
**
**--------------------------------------------------------------------------*/

void free_args(struct arg_t *my_args)
{
  if (my_args->s != NULL) free(my_args->s);
  free(my_args);
}

/*----------------------------------------------------------------------------
**
** Cmdline()
**
** Parse the argv array into the command line structure
**
**--------------------------------------------------------------------------*/

struct arg_t *Cmdline(int argc, char *argv[])
{
  extern char *optarg;
  extern int optind;
  int option_index = 0;
  int c;
  struct arg_t *my_args;
  int errflg = 0;

  static struct option long_options[] =
  {
    {"verbose", 1, 0, 'V'},
    {"startfile", 1, 0, 's'},
    {"readback", 0, 0, 'r'},
    {"help", 0, 0, 'h'},
    {"version", 0, 0, 'v'},
    {0, 0, 0, 0}
  };

  my_args = (struct arg_t *) malloc (sizeof(struct arg_t));

  my_args->V = 0;
  my_args->s = NULL;
  my_args->r = false;
  my_args->h = false;
  my_args->v = false;

  while ((c = getopt_long(argc, argv, "V:s:rhv", long_options, &option_index)) != EOF)
    {
      switch(c)
        {
        case 'V': 
          my_args->V = atoi(optarg);
          break;

        case 's': 
          my_args->s = strdup(optarg);
          break;

        case 'r': 
          my_args->r = true;
          break;

        case 'h': 
          my_args->h = true;
          usage(argv[0]);
          break;

        case 'v': 
          my_args->v = true;
          break;

        default:
          usage(argv[0]);

        }
    } /* while */

  if (errflg)
    usage(argv[0]);

  if (optind >= argc)
    my_args->optind = 0;
  else
    my_args->optind = optind;
  return my_args;
}
